blob: 1016c2da7fa4b2da41a42a7912a779a1d137a651 [file] [log] [blame]
khenaidoocfee5f42018-07-19 22:47:38 -04001#
2# Copyright 2016 the original author or authors.
3#
4# Licensed under the Apache License, Version 2.0 (the "License");
5# you may not use this file except in compliance with the License.
6# You may obtain a copy of the License at
7#
8# http://www.apache.org/licenses/LICENSE-2.0
9#
10# Unless required by applicable law or agreed to in writing, software
11# distributed under the License is distributed on an "AS IS" BASIS,
12# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13# See the License for the specific language governing permissions and
14# limitations under the License.
15#
16
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040017# set default shell
18SHELL = bash -e -o pipefail
Kent Hagerman074d0e02019-04-24 17:58:16 -040019
Zack Williams27f59a42019-05-10 09:12:07 -070020# Variables
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040021VERSION ?= $(shell cat ./VERSION)
Zack Williams27f59a42019-05-10 09:12:07 -070022
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040023DOCKER_LABEL_VCS_DIRTY = false
24ifneq ($(shell git ls-files --others --modified --exclude-standard 2>/dev/null | wc -l | sed -e 's/ //g'),0)
25 DOCKER_LABEL_VCS_DIRTY = true
26endif
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040027## Docker related
David K. Bainbridgee14914d2019-05-24 13:43:05 -070028DOCKER_EXTRA_ARGS ?=
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040029DOCKER_REGISTRY ?=
30DOCKER_REPOSITORY ?=
31DOCKER_TAG ?= ${VERSION}$(shell [[ ${DOCKER_LABEL_VCS_DIRTY} == "true" ]] && echo "-dirty" || true)
32RWCORE_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-rw-core
33ROCORE_IMAGENAME := ${DOCKER_REGISTRY}${DOCKER_REPOSITORY}voltha-ro-core
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040034
35## Docker labels. Only set ref and commit date if committed
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040036DOCKER_LABEL_VCS_URL ?= $(shell git remote get-url $(shell git remote))
37DOCKER_LABEL_VCS_REF = $(shell git rev-parse HEAD)
38DOCKER_LABEL_BUILD_DATE ?= $(shell date -u "+%Y-%m-%dT%H:%M:%SZ")
39DOCKER_LABEL_COMMIT_DATE = $(shell git show -s --format=%cd --date=iso-strict HEAD)
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040040
girishk5259f8e2019-10-10 18:44:44 +000041# Default is GO111MODULE=auto, which will refuse to use go mod if running
42# go less than 1.13.0 and this repository is checked out in GOPATH. For now,
43# force module usage. This affects commands executed from this Makefile, but
44# not the environment inside the Docker build (which does not build from
45# inside a GOPATH).
46export GO111MODULE=on
47
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040048DOCKER_BUILD_ARGS ?= \
David K. Bainbridgee14914d2019-05-24 13:43:05 -070049 ${DOCKER_EXTRA_ARGS} \
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040050 --build-arg org_label_schema_version="${VERSION}" \
51 --build-arg org_label_schema_vcs_url="${DOCKER_LABEL_VCS_URL}" \
52 --build-arg org_label_schema_vcs_ref="${DOCKER_LABEL_VCS_REF}" \
53 --build-arg org_label_schema_build_date="${DOCKER_LABEL_BUILD_DATE}" \
54 --build-arg org_opencord_vcs_commit_date="${DOCKER_LABEL_COMMIT_DATE}" \
55 --build-arg org_opencord_vcs_dirty="${DOCKER_LABEL_VCS_DIRTY}"
56
57DOCKER_BUILD_ARGS_LOCAL ?= ${DOCKER_BUILD_ARGS} \
Kent Hagermanf4a3aab2019-05-22 14:42:34 -040058 --build-arg LOCAL_PROTOS=${LOCAL_PROTOS}
khenaidoocfee5f42018-07-19 22:47:38 -040059
Zack Williamsb9b1afb2019-12-09 15:28:52 -070060.PHONY: rw_core ro_core local-protos
khenaidoocfee5f42018-07-19 22:47:38 -040061
62# This should to be the first and default target in this Makefile
63help:
64 @echo "Usage: make [<target>]"
65 @echo "where available targets are:"
66 @echo
David K. Bainbridge1678e192019-05-17 11:48:29 -070067 @echo "build : Build the docker images."
68 @echo " - If this is the first time you are building, choose 'make build' option."
69 @echo "rw_core : Build the rw_core docker image"
70 @echo "ro_core : Build the ro_core docker image"
David K. Bainbridge1678e192019-05-17 11:48:29 -070071 @echo "clean : Remove files created by the build and tests"
Zack Williamsb9b1afb2019-12-09 15:28:52 -070072 @echo "distclean : Remove sca directory and clean"
David K. Bainbridge1678e192019-05-17 11:48:29 -070073 @echo "docker-push : Push the docker images to an external repository"
David Bainbridge5f3619c2019-07-10 22:51:09 +000074 @echo "lint-dockerfile : Perform static analysis on Dockerfiles"
David K. Bainbridge1678e192019-05-17 11:48:29 -070075 @echo "lint-style : Verify code is properly gofmt-ed"
76 @echo "lint-sanity : Verify that 'go vet' doesn't report any issues"
girishk5259f8e2019-10-10 18:44:44 +000077 @echo "lint-mod : Verify the integrity of the 'mod' files"
David K. Bainbridge1678e192019-05-17 11:48:29 -070078 @echo "lint : Shorthand for lint-style & lint-sanity"
npujar03b018e2019-11-13 15:29:36 +053079 @echo "sca : Runs various SCA through golangci-lint tool"
David K. Bainbridge1678e192019-05-17 11:48:29 -070080 @echo "test : Generate reports for all go tests"
khenaidoocfee5f42018-07-19 22:47:38 -040081 @echo
82
David K. Bainbridge1678e192019-05-17 11:48:29 -070083## Local Development Helpers
84local-protos:
David K. Bainbridge1678e192019-05-17 11:48:29 -070085ifdef LOCAL_PROTOS
William Kurkian905834f2019-11-13 15:40:46 -050086 mkdir -p vendor/github.com/opencord/voltha-protos/v2/go
87 cp -r ${LOCAL_PROTOS}/go/* vendor/github.com/opencord/voltha-protos/v2/go
David K. Bainbridge1678e192019-05-17 11:48:29 -070088endif
89
Scott Bakercb7c88a2019-10-16 18:32:48 -070090## Local Development Helpers
91local-lib-go:
92ifdef LOCAL_LIB_GO
Scott Baker17f1d9d2019-10-25 12:51:25 -070093 mkdir -p vendor/github.com/opencord/voltha-lib-go/v2/pkg
94 cp -r ${LOCAL_LIB_GO}/pkg/* vendor/github.com/opencord/voltha-lib-go/v2/pkg/
Scott Bakercb7c88a2019-10-16 18:32:48 -070095endif
96
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040097## Docker targets
khenaidoocfee5f42018-07-19 22:47:38 -040098
Matt Jeanneret2e3051a2019-05-11 15:01:46 -040099build: docker-build
khenaidoocfee5f42018-07-19 22:47:38 -0400100
Zack Williamsb9b1afb2019-12-09 15:28:52 -0700101docker-build: rw_core ro_core
sslobodra3ea7d42019-01-16 15:03:16 -0500102
Scott Bakercb7c88a2019-10-16 18:32:48 -0700103rw_core: local-protos local-lib-go
Kent Hagermanf4a3aab2019-05-22 14:42:34 -0400104 docker build $(DOCKER_BUILD_ARGS) -t ${RWCORE_IMAGENAME}:${DOCKER_TAG} -t ${RWCORE_IMAGENAME}:latest -f docker/Dockerfile.rw_core .
khenaidoocfee5f42018-07-19 22:47:38 -0400105
Scott Bakercb7c88a2019-10-16 18:32:48 -0700106ro_core: local-protos local-lib-go
Kent Hagermanf4a3aab2019-05-22 14:42:34 -0400107 docker build $(DOCKER_BUILD_ARGS) -t ${ROCORE_IMAGENAME}:${DOCKER_TAG} -t ${ROCORE_IMAGENAME}:latest -f docker/Dockerfile.ro_core .
Stephane Barbariea75791c2019-01-24 10:58:06 -0500108
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400109docker-push:
Kent Hagermanf4a3aab2019-05-22 14:42:34 -0400110 docker push ${RWCORE_IMAGENAME}:${DOCKER_TAG}
111 docker push ${ROCORE_IMAGENAME}:${DOCKER_TAG}
Matt Jeanneret2e3051a2019-05-11 15:01:46 -0400112
113## lint and unit tests
khenaidood2b6df92018-12-13 16:37:20 -0500114
David Bainbridge5f3619c2019-07-10 22:51:09 +0000115PATH:=$(GOPATH)/bin:$(PATH)
116HADOLINT=$(shell PATH=$(GOPATH):$(PATH) which hadolint)
117lint-dockerfile:
118ifeq (,$(shell PATH=$(GOPATH):$(PATH) which hadolint))
119 mkdir -p $(GOPATH)/bin
120 curl -o $(GOPATH)/bin/hadolint -sNSL https://github.com/hadolint/hadolint/releases/download/v1.17.1/hadolint-$(shell uname -s)-$(shell uname -m)
121 chmod 755 $(GOPATH)/bin/hadolint
122endif
123 @echo "Running Dockerfile lint check ..."
124 @hadolint $$(find . -name "Dockerfile.*")
125 @echo "Dockerfile lint check OK"
126
Kent Hagerman074d0e02019-04-24 17:58:16 -0400127lint-style:
Zack Williams7cf78002019-04-30 21:45:35 -0700128ifeq (,$(shell which gofmt))
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400129 go get -u github.com/golang/go/src/cmd/gofmt
Zack Williams7cf78002019-04-30 21:45:35 -0700130endif
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400131 @echo "Running style check..."
132 @gofmt_out="$$(gofmt -l $$(find . -name '*.go' -not -path './vendor/*'))" ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700133 if [ ! -z "$$gofmt_out" ]; then \
134 echo "$$gofmt_out" ;\
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400135 echo "Style check failed on one or more files ^, run 'go fmt' to fix." ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700136 exit 1 ;\
Kent Hagerman074d0e02019-04-24 17:58:16 -0400137 fi
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400138 @echo "Style check OK"
Kent Hagerman074d0e02019-04-24 17:58:16 -0400139
140lint-sanity:
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400141 @echo "Running sanity check..."
girishk5259f8e2019-10-10 18:44:44 +0000142 @go vet -mod=vendor ./...
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400143 @echo "Sanity check OK"
Kent Hagerman074d0e02019-04-24 17:58:16 -0400144
girishk5259f8e2019-10-10 18:44:44 +0000145lint-mod:
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400146 @echo "Running dependency check..."
girishk5259f8e2019-10-10 18:44:44 +0000147 @go mod verify
Scott Bakere4c2a982019-11-21 16:32:03 -0800148 @echo "Dependency check OK. Running vendor check..."
149 @git status > /dev/null
150 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Staged or modified files must be committed before running this test" && echo "`git status`" && exit 1)
151 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files must be cleaned up before running this test" && echo "`git status`" && exit 1)
152 go mod tidy
153 go mod vendor
154 @git status > /dev/null
155 @git diff-index --quiet HEAD -- go.mod go.sum vendor || (echo "ERROR: Modified files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
156 @[[ `git ls-files --exclude-standard --others go.mod go.sum vendor` == "" ]] || (echo "ERROR: Untracked files detected after running go mod tidy / go mod vendor" && echo "`git status`" && exit 1)
157 @echo "Vendor check OK."
158
Kent Hagerman0ab4cb22019-04-24 13:13:35 -0400159
girishk5259f8e2019-10-10 18:44:44 +0000160lint: lint-style lint-sanity lint-mod lint-dockerfile
Kent Hagerman074d0e02019-04-24 17:58:16 -0400161
Scott Baker18ea5a42019-10-15 16:08:42 -0700162# Rules to automatically install golangci-lint
163GOLANGCI_LINT_TOOL?=$(shell which golangci-lint)
164ifeq (,$(GOLANGCI_LINT_TOOL))
165GOLANGCI_LINT_TOOL=$(GOPATH)/bin/golangci-lint
166golangci_lint_tool_install:
167 # Same version as installed by Jenkins ci-management
168 # Note that install using `go get` is not recommended as per https://github.com/golangci/golangci-lint
169 curl -sfL https://raw.githubusercontent.com/golangci/golangci-lint/master/install.sh| sh -s -- -b $(GOPATH)/bin v1.17.0
170else
171golangci_lint_tool_install:
172endif
David K. Bainbridge1678e192019-05-17 11:48:29 -0700173
Scott Baker18ea5a42019-10-15 16:08:42 -0700174# Rules to automatically install go-junit-report
175GO_JUNIT_REPORT?=$(shell which go-junit-report)
Zack Williams7cf78002019-04-30 21:45:35 -0700176ifeq (,$(GO_JUNIT_REPORT))
Scott Baker18ea5a42019-10-15 16:08:42 -0700177GO_JUNIT_REPORT=$(GOPATH)/bin/go-junit-report
178go_junit_install:
Zack Williams7cf78002019-04-30 21:45:35 -0700179 go get -u github.com/jstemmer/go-junit-report
Scott Baker18ea5a42019-10-15 16:08:42 -0700180else
181go_junit_install:
Zack Williams7cf78002019-04-30 21:45:35 -0700182endif
Scott Baker18ea5a42019-10-15 16:08:42 -0700183
184# Rules to automatically install gocover-covertura
185GOCOVER_COBERTURA?=$(shell which gocover-cobertura)
Zack Williams7cf78002019-04-30 21:45:35 -0700186ifeq (,$(GOCOVER_COBERTURA))
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400187 @GOCOVER_COBERTURA=$(GOPATH)/bin/gocover-cobertura
Scott Baker18ea5a42019-10-15 16:08:42 -0700188gocover_cobertura_install:
189 go get -u github.com/t-yuki/gocover-cobertura
190else
191gocover_cobertura_install:
Zack Williams7cf78002019-04-30 21:45:35 -0700192endif
Scott Baker18ea5a42019-10-15 16:08:42 -0700193
194sca: golangci_lint_tool_install
195 rm -rf ./sca-report
196 @mkdir -p ./sca-report
Zack Williamsb9b1afb2019-12-09 15:28:52 -0700197 $(GOLANGCI_LINT_TOOL) run -E golint -D structcheck --out-format junit-xml ./rw_core/... ./ro_core/... ./tests/... ./common/... 2>&1 | tee ./sca-report/sca-report.xml
Scott Baker18ea5a42019-10-15 16:08:42 -0700198
Scott Bakercb7c88a2019-10-16 18:32:48 -0700199test: go_junit_install gocover_cobertura_install local-lib-go
Kent Hagermanca4c51e2019-05-02 12:28:55 -0400200 @mkdir -p ./tests/results
girishk5259f8e2019-10-10 18:44:44 +0000201 @go test -mod=vendor -v -coverprofile ./tests/results/go-test-coverage.out -covermode count ./... 2>&1 | tee ./tests/results/go-test-results.out ;\
Zack Williams7cf78002019-04-30 21:45:35 -0700202 RETURN=$$? ;\
203 $(GO_JUNIT_REPORT) < ./tests/results/go-test-results.out > ./tests/results/go-test-results.xml ;\
204 $(GOCOVER_COBERTURA) < ./tests/results/go-test-coverage.out > ./tests/results/go-test-coverage.xml ;\
205 exit $$RETURN
Kent Hagerman074d0e02019-04-24 17:58:16 -0400206
David K. Bainbridge1678e192019-05-17 11:48:29 -0700207clean:
David K. Bainbridge1678e192019-05-17 11:48:29 -0700208
209distclean: clean
Zack Williamsb9b1afb2019-12-09 15:28:52 -0700210 rm -rf ./sca_report
David K. Bainbridge1678e192019-05-17 11:48:29 -0700211
Scott Bakercb7c88a2019-10-16 18:32:48 -0700212mod-update:
213 go mod tidy
214 go mod vendor
215
khenaidoocfee5f42018-07-19 22:47:38 -0400216# end file